package Mason::Plugin::WithRole::Component::Moose::Role;

use Moose::Role                ();
use Method::Signatures::Simple ();
use MooseX::HasDefaults::RW    ();
use Moose::Exporter;
Moose::Exporter->setup_import_methods( also => ['Moose::Role'] );

sub init_meta {
    my $class     = shift;
    my %params    = @_;
    my $for_class = $params{for_class};

    {
        no strict 'refs';
        *{ $for_class . '::CLASS' } = sub () { $for_class };    # like CLASS.pm
        *{ $for_class . '::CLASS' } = \$for_class;
        *{ $for_class . '::cmeta' } = \&Mason::Component::cmeta;
    }

    Method::Signatures::Simple->import( into => $for_class );
    MooseX::HasDefaults::RW->init_meta(@_);
    #Moose::Role->init_meta(@_);
}

1;
